% region growing segmentation
function simg = segrgn(img, thres)
	thres
	neigh_offs = [ 1 0 ; -1 0 ; 0 1 ; 0 -1 ];
	seed = [349, 393];

	[xsz, ysz] = size(img);
	visited = zeros(xsz, ysz);
	visited(seed(1), seed(2)) = 1;

	bound = seed;

	% while the queue still has points to process (rows)
	while(size(bound, 1) > 0)
		% get the first element (x,y coordinates)
		nextpt = bound(1,:);
		bound = bound(2:end,:);

		% if this pixel is greater than the threshold ...
		img(nextpt(1), nextpt(2));
		if img(nextpt(1), nextpt(2)) >= thres
			% ... we shall visit it.
			visited(nextpt(1), nextpt(2)) = 1;

			% for all neighbors ...
			for i=1:1:4
				% calculate the neighbor coordinates
				neigh_pt = nextpt + neigh_offs(i,:);

				% if we haven't visited it, add it to the queue
				if neigh_pt(1) > 0 && neigh_pt(1) <= xsz && neigh_pt(2) > 0 && neigh_pt(2) <= ysz && visited(neigh_pt(1), neigh_pt(2)) == 0
					bound = [bound ; neigh_pt];
					visited(neigh_pt(1), neigh_pt(2)) = 1;
				end
			end
		end
	end

	simg = visited;
end
